@import "../../../../styles/global/var";
@import "../../../../styles/global/var-pages";
@import "../../../../styles/ui/components/animation";


@mixin testStatuses {
    &._aborted {
        background-color: $gray5f5;
        &._selected {
            background-color: darken($gray5f5, 4.71);
        }
    }
    &._danger {
        background-color: $red0f1;
        &._selected {
            background-color: darken(desaturate($pink-bg-light-new, 50.00), 5.10);
        }
    }
    &._info {
        background-color: $blueaff;
        &._selected {
            background-color: darken(desaturate(adjust-hue($state-info-bg, -2), 42.88), 4.90);
        }
    }
    &._success {
        background-color: $greenff6;
        &._selected {
            background-color: darken(desaturate($green-bg-light-new, 33.30), 4.71);
        }
    }
    &._warning {
        background-color: $yellow8e6;
        &._selected {
            background-color: darken(desaturate(adjust-hue($state-warning-bg, -1), 60.47), 4.90);
        }
    }
}

test-card {
    display: block;
    position: relative;
    &:last-of-type {
        .test-card {
            border-bottom: 0;
        }
    }
}

.test-card {
    display: flex;
    justify-content: stretch;
    margin: 0;
    box-shadow: inset 0px -1px 0px $gray8be;
    position: relative;

    @include testStatuses;
    &._selected {
        background-color: rgba($black, .05);
        .test-card__clickable:hover {
            background-color: transparent;
        }
    }
    &._highlighting {
        animation: shaking 1.5s linear 1;
    }

    &__copy {
        @include testStatuses;

        &._aborted {
            &::before {
                background: linear-gradient(90deg, transparent 0%, $gray5f5 100%);
            }
            &._selected {
                &::before {
                    background: linear-gradient(90deg, transparent 0%, darken($gray5f5, 4.71) 100%);
                }
            }
        }
        &._danger {
            &::before {
                background: linear-gradient(90deg, transparent 0%, $red0f1 100%);
            }
            &._selected {
                &::before {
                    background: linear-gradient(90deg, transparent 0%, darken(desaturate($pink-bg-light-new, 50.00), 5.10) 100%);
                }
            }
        }
        &._info {
            &::before {
                background: linear-gradient(90deg, transparent 0%, $blueaff 100%);
            }
            &._selected {
                &::before {
                    background: linear-gradient(90deg, transparent 0%, darken(desaturate(adjust-hue($state-info-bg, -2), 42.88), 4.90) 100%);
                }
            }
        }
        &._success {
            &::before {
                background: linear-gradient(90deg, transparent 0%, $greenff6 100%);
            }
            &._selected {
                &::before {
                    background: linear-gradient(90deg, transparent 0%, darken(desaturate($green-bg-light-new, 33.30), 4.71) 100%);
                }
            }
        }
        &._warning {
            &::before {
                background: linear-gradient(90deg, transparent 0%, $yellow8e6 100%);
            }
            &._selected {
                &::before {
                    background: linear-gradient(90deg, transparent 0%, darken(desaturate(adjust-hue($state-warning-bg, -1), 60.47), 4.90) 100%);
                }
            }

        }
    }

    &__col {
        &-settings,
        &-selection {
            flex: none;
            width: 56px;
            padding: 16px 0 12px;
            display: flex;
            justify-content: center;
        }

        &-main {
            flex: auto;
            padding: 16px 0 12px;
            margin-right: auto;
        }

        &-settings {
            padding-top: 12px;
        }
    }

    &__header {
        display: grid;
        grid-template-areas:
            "info labels"
            "meta meta";
        grid-template-columns: minmax(50%, 1fr) auto;
    }

    &__info {
        grid-area: info;
        width: auto;
        padding-right: 30px;
        min-width: 0;
    }
    &__labels {
        grid-area: labels;
        display: flex;
        flex-wrap: wrap;
        align-items: center;

        test-ticket {
            margin-right: 8px;
            margin-bottom: 8px;
            position: relative;
            z-index: 2;
            flex: none;
            &:last-of-type {
                margin-right: 0;
            }
        }
        .issue-references__arr {
            margin-right: 8px;
        }
    }
    &__title {
        color: $black;
        font-weight: 700;
        font-size: 16px;
        line-height: 24px;
        margin-bottom: 8px;
        word-break: break-word;
        max-width: 100%;
        &-text,
        &-badge {
            position: relative;
            z-index: 2;
        }
        &-badge {
           background-color: #DF4150;
        }
        &-text {
            width: fit-content;
            overflow: hidden;
            text-overflow: ellipsis;
            position: relative;
            padding-right: 0;
            white-space: nowrap;
            max-width: 100%;
            @media(max-width: $screen-md) {
                white-space: normal;
            }
            &:hover .test-card__copy {
                transform: translateX(0);
                transition: transform 0.25s ease-in-out;
            }
        }
    }
    &__copy {
        border: none;
        position: absolute;
        right: 0;
        top: 0;
        width: 24px;
        padding: 0;
        height: 24px;
        background-color: transparent;
        transform: translateX(150%);
        transition: none;
        font-size: 0;
        box-shadow: none;
        &-icon.material-icons {
            font-size: 16px;
            line-height: 24px;
            &:hover {
                color: $black;
            }
        }
        &::before {
            content: '';
            cursor: default;
            position: absolute;
            top: 0;
            right: 100%;
            height: 100%;
            width: 50%;
        }
        @media(max-width: $screen-md) {
            display: none;
        }
    }
    &__meta {
        grid-area: meta;
        display: flex;
        flex-wrap: wrap;
        align-items: center;

        &-item {
            color: $gray57c;
            font-size: 12px;
            line-height: 16px;
            display: flex;
            align-items: center;
            margin-bottom: 8px;
            margin-right: 16px;
            &-link {
                color: $gray57c;
                display: flex;
                align-items: center;
                max-width: 120px;
            }
            &-icon {
                font-size: 16px;
                display: inline-block;
                width: 16px;
                min-width: 16px;
                height: 16px;
                min-height: 16px;
                text-align: center;
                margin-right: 4px;
            }
            &-text {
                white-space: nowrap;
                overflow-x: hidden;
                text-overflow: ellipsis;
            }
            &._sessions,
            &._artifact,
            &._artifact-less,
            &._artifact-more,
            &._label,
            &._label-less,
            &._label-more {
                position: relative;
                z-index: 2;
            }
            &._artifact-less,
            &._artifact-more,
            &._label-less,
            &._label-more {
                .material-icons {
                    font-size: 16px;
                    height: 16px;
                    width: 16px;
                    min-height: 16px;
                    min-width: 16px;
                    color: currentColor;
                }
            }
            &._artifact-less,
            &._artifact-more {
                display: inline-flex;
                vertical-align: middle;
                align-items: center;
                max-height: 16px;
                font-size: 0;
                line-height: 16px;
                padding: 0;
                border: 0;
                background-color: transparent;
                transition: color .15s ease-in-out;
                span {
                    font-size: 12px;
                    line-height: 16px;
                    font-weight: 700;
                    text-decoration: underline;
                }
                &:hover {
                    color: $black;
                }
            }
            &._label-less,
            &._label-more {
                display: inline-block;
                vertical-align: middle;
                max-height: 16px;
                border-radius: 8px;
                font-size: 0;
                line-height: 16px;
                padding: 0 8px;
                color: $gray57c;
                box-shadow: 0 0 0 1px $gray8be;
                transition: background-color .15s ease-in-out;
                background-color: $table-bg-hover;
                border: 0;
                text-align: center;
                width: 32px;
                &:hover {
                    text-decoration: none;
                    background-color: rgba($black, 0.1);
                }
            }
            &._sessions {
                transition: color .25s ease-in-out;
                &:hover {
                    cursor: pointer;
                    color: $black;
                }
                .test-card__meta-item-text {
                    text-decoration: underline;
                }
            }
        }
    }

    &__stacktrace {
        margin-top: 4px;
        font-weight: 500;
        font-size: 14px;
        line-height: 24px;
        color: $gray57c;
        position: relative;
        z-index: 2;
        border-radius: 4px;
        &._skipped {
            color: $yellowa00;
            border-color: $yellowc99;
        }
        &._failed {
            color: $brand-danger-new;
            border-color: $red1c2;
        }
        &._isBorder {
            border-width: 1px;
            border-style: solid;
            .test-card__stacktrace-title {
                padding-left: 16px;
            }
            .test-card__stacktrace-message {
                padding: 0 16px;
            }
            @media(max-width: $screen-tablet-2) {
                .test-card__stacktrace-title {
                    padding-left: 8px;
                }
                .test-card__stacktrace-message {
                    padding: 0 8px;
                }
            }
        }
        &-message {
            word-break: break-word;
            border-radius: 4px;
        }
        &-message + &-title {
            margin-top: 16px;
        }
        &-title {
            display: flex;
            align-items: flex-start;
            border-radius: 4px;
            max-width: 100%;
            &-text {
                word-break: break-word;
                margin-right: auto;
            }
            .material-icons {
                margin-right: 0;
                margin-left: 16px;
            }
            &:hover {
                background: rgba($white, 0.5);
            }
            &._expanded {
                font-weight: 700;
                &._failed {
                    border-bottom: 1px solid $red1c2;
                }
                &._skipped {
                    border-bottom: 1px solid $yellowc99;
                }
            }
        }
    }

    &__checkbox {
        position: relative;
        z-index: 2;
        width: 24px;
        height: 24px;
        min-width: 24px;
        min-height: 24px;
        .md-container {
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
        }
        &:not(.md-checked) .md-icon {
            border-color: $gray8be;
        }
    }

    &__clickable {
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        left: 0;
        z-index: 1;
        cursor: pointer;
        &:hover {
            background-color: rgba($black, .05);
        }
    }

    &__menu {
        position: relative;
        z-index: 2;
    }

    @media(max-width: $screen-tablet-2) {
        &__header {
            display: grid;
            grid-template-areas:
            "info"
            "meta"
            "labels";
            grid-template-columns: auto;
        }
        &__info {
            padding-right: 0;
        }
        &__labels {
            margin-top: 4px;
        }
    }
    @media(max-width: $screen-phone) {
        display: block;
        &__copy {
            display: none;
        }
        &__col {
            &-settings,
            &-selection {
                position: absolute;
                padding-bottom: 0;
                top: 0;
            }
            &-settings {
                right: 0;
            }
            &-selection {
                left: 0;
            }
            &-main {
                padding: 12px 16px;
            }
        }
        &__title {
            padding-right: 40px;
            padding-left: 40px;
            min-height: 30px;
        }
    }
}
